diff --git a/src/java.base/linux/classes/sun/nio/fs/LinuxWatchService.java b/src/java.base/linux/classes/sun/nio/fs/LinuxWatchService.java
index 863b8cd7aff4..8e369ae8bdc8 100644
--- a/src/java.base/linux/classes/sun/nio/fs/LinuxWatchService.java
+++ b/src/java.base/linux/classes/sun/nio/fs/LinuxWatchService.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2008, 2022, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2008, 2023, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -226,14 +226,11 @@ Object implRegister(Path obj,
             }
 
             // no modifiers supported at this time
-            for (WatchEvent.Modifier modifier : modifiers) {
+            if (modifiers.length > 0) {
+                WatchEvent.Modifier modifier = modifiers[0];
                 if (modifier == null)
                     return new NullPointerException();
-                if (!ExtendedOptions.SENSITIVITY_HIGH.matches(modifier) &&
-                        !ExtendedOptions.SENSITIVITY_MEDIUM.matches(modifier) &&
-                        !ExtendedOptions.SENSITIVITY_LOW.matches(modifier)) {
-                    return new UnsupportedOperationException("Modifier not supported");
-                }
+                return new UnsupportedOperationException("Modifier not supported");
             }
 
             // check file is directory
diff --git a/src/java.base/share/classes/jdk/internal/misc/FileSystemOption.java b/src/java.base/share/classes/jdk/internal/misc/FileSystemOption.java
index 5a55b7df67ce..2e6a372770df 100644
--- a/src/java.base/share/classes/jdk/internal/misc/FileSystemOption.java
+++ b/src/java.base/share/classes/jdk/internal/misc/FileSystemOption.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2018, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2018, 2023, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -47,12 +47,6 @@
         new FileSystemOption<>(ExtendedOptions.FILE_TREE);
     public static final FileSystemOption<Void> DIRECT =
         new FileSystemOption<>(ExtendedOptions.DIRECT);
-    public static final FileSystemOption<Integer> SENSITIVITY_HIGH =
-        new FileSystemOption<>(ExtendedOptions.SENSITIVITY_HIGH);
-    public static final FileSystemOption<Integer> SENSITIVITY_MEDIUM =
-        new FileSystemOption<>(ExtendedOptions.SENSITIVITY_MEDIUM);
-    public static final FileSystemOption<Integer> SENSITIVITY_LOW =
-        new FileSystemOption<>(ExtendedOptions.SENSITIVITY_LOW);
 
     private final ExtendedOptions.InternalOption<T> internalOption;
     private FileSystemOption(ExtendedOptions.InternalOption<T> option) {
diff --git a/src/java.base/share/classes/sun/nio/fs/ExtendedOptions.java b/src/java.base/share/classes/sun/nio/fs/ExtendedOptions.java
index 673c32966969..fb8ae53ef7d1 100644
--- a/src/java.base/share/classes/sun/nio/fs/ExtendedOptions.java
+++ b/src/java.base/share/classes/sun/nio/fs/ExtendedOptions.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2016, 2017, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2016, 2023, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -138,8 +138,4 @@ public T parameter() {
     public static final InternalOption<Void> FILE_TREE = new InternalOption<>();
 
     public static final InternalOption<Void> DIRECT = new InternalOption<>();
-
-    public static final InternalOption<Integer> SENSITIVITY_HIGH = new InternalOption<>();
-    public static final InternalOption<Integer> SENSITIVITY_MEDIUM = new InternalOption<>();
-    public static final InternalOption<Integer> SENSITIVITY_LOW = new InternalOption<>();
 }
diff --git a/src/java.base/share/classes/sun/nio/fs/PollingWatchService.java b/src/java.base/share/classes/sun/nio/fs/PollingWatchService.java
index ce76e6ef65ad..0e581f234975 100644
--- a/src/java.base/share/classes/sun/nio/fs/PollingWatchService.java
+++ b/src/java.base/share/classes/sun/nio/fs/PollingWatchService.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2008, 2022, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2008, 2023, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -62,8 +62,8 @@
 class PollingWatchService
     extends AbstractWatchService
 {
-    // default polling interval in seconds
-    private static final int DEFAULT_POLLING_INTERVAL = 2;
+    // polling interval in seconds
+    private static final int POLLING_INTERVAL = 2;
 
     // map of registrations
     private final Map<Object, PollingWatchKey> map = new HashMap<>();
@@ -118,21 +118,12 @@ WatchKey register(final Path path,
         if (eventSet.isEmpty())
             throw new IllegalArgumentException("No events to register");
 
-        // Extended modifiers may be used to specify the sensitivity level
-        int sensitivity = DEFAULT_POLLING_INTERVAL;
-        for (WatchEvent.Modifier modifier : modifiers) {
+        // no modifiers supported at this time
+        if (modifiers.length > 0) {
+            WatchEvent.Modifier modifier = modifiers[0];
             if (modifier == null)
                 throw new NullPointerException();
-
-            if (ExtendedOptions.SENSITIVITY_HIGH.matches(modifier)) {
-                sensitivity = ExtendedOptions.SENSITIVITY_HIGH.parameter();
-            } else if (ExtendedOptions.SENSITIVITY_MEDIUM.matches(modifier)) {
-                sensitivity = ExtendedOptions.SENSITIVITY_MEDIUM.parameter();
-            } else if (ExtendedOptions.SENSITIVITY_LOW.matches(modifier)) {
-                sensitivity = ExtendedOptions.SENSITIVITY_LOW.parameter();
-            } else {
-                throw new UnsupportedOperationException("Modifier not supported");
-            }
+            throw new UnsupportedOperationException("Modifier not supported");
         }
 
         // check if watch service is closed
@@ -142,12 +133,12 @@ WatchKey register(final Path path,
         // registration is done in privileged block as it requires the
         // attributes of the entries in the directory.
         try {
-            int value = sensitivity;
             return AccessController.doPrivileged(
                 new PrivilegedExceptionAction<PollingWatchKey>() {
                     @Override
                     public PollingWatchKey run() throws IOException {
-                        return doPrivilegedRegister(path, eventSet, value);
+                        return doPrivilegedRegister(path, eventSet,
+                                                    POLLING_INTERVAL);
                     }
                 });
         } catch (PrivilegedActionException pae) {
diff --git a/src/java.base/windows/classes/sun/nio/fs/WindowsWatchService.java b/src/java.base/windows/classes/sun/nio/fs/WindowsWatchService.java
index d5b822850751..8b8d6cf3d5b5 100644
--- a/src/java.base/windows/classes/sun/nio/fs/WindowsWatchService.java
+++ b/src/java.base/windows/classes/sun/nio/fs/WindowsWatchService.java
@@ -346,11 +346,7 @@ Object implRegister(Path obj,
                 } else {
                     if (modifier == null)
                         return new NullPointerException();
-                    if (!ExtendedOptions.SENSITIVITY_HIGH.matches(modifier) &&
-                            !ExtendedOptions.SENSITIVITY_MEDIUM.matches(modifier) &&
-                            !ExtendedOptions.SENSITIVITY_LOW.matches(modifier)) {
-                        return new UnsupportedOperationException("Modifier not supported");
-                    }
+                    return new UnsupportedOperationException("Modifier not supported");
                 }
             }
 
diff --git a/src/jdk.unsupported/share/classes/com/sun/nio/file/SensitivityWatchEventModifier.java b/src/jdk.unsupported/share/classes/com/sun/nio/file/SensitivityWatchEventModifier.java
deleted file mode 100644
index 85ae1e715c49..000000000000
--- a/src/jdk.unsupported/share/classes/com/sun/nio/file/SensitivityWatchEventModifier.java
+++ /dev/null
@@ -1,65 +0,0 @@
-/*
- * Copyright (c) 2007, 2018, Oracle and/or its affiliates. All rights reserved.
- * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
- *
- * This code is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License version 2 only, as
- * published by the Free Software Foundation.  Oracle designates this
- * particular file as subject to the "Classpath" exception as provided
- * by Oracle in the LICENSE file that accompanied this code.
- *
- * This code is distributed in the hope that it will be useful, but WITHOUT
- * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
- * version 2 for more details (a copy is included in the LICENSE file that
- * accompanied this code).
- *
- * You should have received a copy of the GNU General Public License version
- * 2 along with this work; if not, write to the Free Software Foundation,
- * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
- *
- * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
- * or visit www.oracle.com if you need additional information or have any
- * questions.
- */
-
-package com.sun.nio.file;
-
-import java.nio.file.WatchEvent.Modifier;
-import jdk.internal.misc.FileSystemOption;
-
-/**
- * Defines the <em>sensitivity levels</em> when registering objects with a
- * watch service implementation that polls the file system.
- *
- * @since 1.7
- */
-
-public enum SensitivityWatchEventModifier implements Modifier {
-    /**
-     * High sensitivity.
-     */
-    HIGH(FileSystemOption.SENSITIVITY_HIGH, 2),
-    /**
-     * Medium sensitivity.
-     */
-    MEDIUM(FileSystemOption.SENSITIVITY_MEDIUM, 10),
-    /**
-     * Low sensitivity.
-     */
-    LOW(FileSystemOption.SENSITIVITY_LOW, 30);
-
-    /**
-     * Returns the sensitivity in seconds.
-     */
-    public int sensitivityValueInSeconds() {
-        return sensitivity;
-    }
-
-    private final int sensitivity;
-    private SensitivityWatchEventModifier(FileSystemOption<Integer> option,
-                                          int sensitivity) {
-        this.sensitivity = sensitivity;
-        option.register(this, sensitivity);
-    }
-}
diff --git a/test/jdk/java/nio/file/WatchService/SensitivityModifier.java b/test/jdk/java/nio/file/WatchService/SensitivityModifier.java
deleted file mode 100644
index b43a4b926ceb..000000000000
--- a/test/jdk/java/nio/file/WatchService/SensitivityModifier.java
+++ /dev/null
@@ -1,152 +0,0 @@
-/*
- * Copyright (c) 2008, 2021, Oracle and/or its affiliates. All rights reserved.
- * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
- *
- * This code is free software; you can redistribute it and/or modify it
- * under the terms of the GNU General Public License version 2 only, as
- * published by the Free Software Foundation.
- *
- * This code is distributed in the hope that it will be useful, but WITHOUT
- * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
- * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
- * version 2 for more details (a copy is included in the LICENSE file that
- * accompanied this code).
- *
- * You should have received a copy of the GNU General Public License version
- * 2 along with this work; if not, write to the Free Software Foundation,
- * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
- *
- * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
- * or visit www.oracle.com if you need additional information or have any
- * questions.
- */
-
-/* @test
- * @bug 4313887
- * @summary Sanity test for JDK-specific sensitivity level watch event modifier
- * @modules jdk.unsupported
- * @library .. /test/lib
- * @build jdk.test.lib.Platform
- * @build jdk.test.lib.RandomFactory
- * @run main/timeout=240 SensitivityModifier
- * @key randomness
- */
-
-import java.nio.file.Files;
-import java.nio.file.FileSystem;
-import java.nio.file.Path;
-import java.nio.file.WatchEvent;
-import java.nio.file.WatchKey;
-import java.nio.file.WatchService;
-import static java.nio.file.StandardWatchEventKinds.*;
-import java.io.OutputStream;
-import java.io.IOException;
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Random;
-import java.util.concurrent.TimeUnit;
-import com.sun.nio.file.SensitivityWatchEventModifier;
-import jdk.test.lib.Platform;
-import jdk.test.lib.RandomFactory;
-
-public class SensitivityModifier {
-    // on macOS and other platforms, watch services might be based on polling
-    // requiring a longer timeout to detect events before returning
-    static final long POLL_TIMEOUT_SECONDS =
-        Platform.isLinux() || Platform.isWindows() ? 1 : 2;
-
-    static final Random RAND = RandomFactory.getRandom();
-
-    static final Map<Path,Integer> pathToTime = new HashMap<>();
-
-    static void register(Path[] dirs, WatchService watcher) throws IOException {
-        pathToTime.clear();
-        SensitivityWatchEventModifier[] sensitivities =
-            SensitivityWatchEventModifier.values();
-        for (int i=0; i<dirs.length; i++) {
-            SensitivityWatchEventModifier sensitivity =
-                sensitivities[RAND.nextInt(sensitivities.length)];
-            Path dir = dirs[i];
-            dir.register(watcher, new WatchEvent.Kind<?>[]{ ENTRY_MODIFY },
-                sensitivity);
-            pathToTime.put(dir, sensitivity.sensitivityValueInSeconds());
-        }
-    }
-
-    @SuppressWarnings("unchecked")
-    static void doTest(Path top) throws Exception {
-        FileSystem fs = top.getFileSystem();
-        try (WatchService watcher = fs.newWatchService()) {
-
-            // create directories and files
-            int nDirs = 5 + RAND.nextInt(20);
-            int nFiles = 50 + RAND.nextInt(50);
-            Path[] dirs = new Path[nDirs];
-            Path[] files = new Path[nFiles];
-            for (int i=0; i<nDirs; i++) {
-                dirs[i] = Files.createDirectory(top.resolve("dir" + i));
-            }
-            for (int i=0; i<nFiles; i++) {
-                Path dir = dirs[RAND.nextInt(nDirs)];
-                files[i] = Files.createFile(dir.resolve("file" + i));
-            }
-
-            // register the directories (random sensitivity)
-            register(dirs, watcher);
-
-            // sleep a bit here to ensure that modification to the first file
-            // can be detected by polling implementations (ie: last modified time
-            // may not change otherwise).
-            try { Thread.sleep(1000); } catch (InterruptedException e) { }
-
-            // modify files and check that events are received
-            for (int i=0; i<10; i++) {
-                Path file = files[RAND.nextInt(nFiles)];
-                System.out.println("Modify: " + file);
-                try (OutputStream out = Files.newOutputStream(file)) {
-                    out.write(new byte[100]);
-                }
-
-                System.out.println("Waiting for event(s)...");
-                boolean eventReceived = false;
-                WatchKey key = watcher.take();
-                do {
-                    for (WatchEvent<?> event: key.pollEvents()) {
-                        if (event.kind() != ENTRY_MODIFY)
-                            throw new RuntimeException("Unexpected event: " + event);
-                        Path name = ((WatchEvent<Path>)event).context();
-                        if (name.equals(file.getFileName())) {
-                            eventReceived = true;
-                            break;
-                        }
-                    }
-                    key.reset();
-                    key = watcher.poll(POLL_TIMEOUT_SECONDS, TimeUnit.SECONDS);
-                } while (key != null);
-
-                // we should have received at least one ENTRY_MODIFY event
-                if (eventReceived) {
-                    System.out.println("Event OK");
-                } else {
-                    Path parent = file.getParent();
-                    String msg = String.format("No ENTRY_MODIFY event received for %s (dir: %s, sensitivity: %d)",
-                            file, parent, pathToTime.get(parent));
-                    throw new RuntimeException(msg);
-                }
-
-                // re-register the directories to force changing their sensitivity
-                // level
-                register(dirs, watcher);
-            }
-        }
-    }
-
-    public static void main(String[] args) throws Exception {
-        Path dir = TestUtil.createTemporaryDirectory();
-        try {
-            doTest(dir);
-        } finally {
-            TestUtil.removeAll(dir);
-        }
-    }
-}