diff --git a/src/java.base/share/classes/java/net/HttpURLConnection.java b/src/java.base/share/classes/java/net/HttpURLConnection.java
index 20b9068e7f364..8ecbb98e7c6d0 100644
--- a/src/java.base/share/classes/java/net/HttpURLConnection.java
+++ b/src/java.base/share/classes/java/net/HttpURLConnection.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1996, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1996, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -606,7 +606,13 @@ public long getHeaderFieldDate(String name, long defaultValue) {
      * @return a {@code SocketPermission} object representing the
      *         permission necessary to connect to the destination
      *         host and port.
+     *
+     * @deprecated
+     * Permissions can no longer be used for controlling access to resources
+     * as the Security Manager is no longer supported.
      */
+    @Deprecated(since = "25", forRemoval = true)
+    @SuppressWarnings("removal")
     public Permission getPermission() throws IOException {
         int port = url.getPort();
         port = port < 0 ? 80 : port;
diff --git a/src/java.base/share/classes/java/net/NetPermission.java b/src/java.base/share/classes/java/net/NetPermission.java
index 7c52ba5ae7cf2..d2a086e9c3a7f 100644
--- a/src/java.base/share/classes/java/net/NetPermission.java
+++ b/src/java.base/share/classes/java/net/NetPermission.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1997, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -40,7 +40,7 @@
  * to signify a wildcard match. For example: "foo.*" and "*" signify a wildcard
  * match, while "*foo" and "a*b" do not.
  *
- * @apiNote
+ * @deprecated
  * This permission cannot be used for controlling access to resources
  * as the Security Manager is no longer supported.
  *
@@ -56,6 +56,7 @@
  * @since 1.2
  */
 
+@Deprecated(since = "25", forRemoval = true)
 public final class NetPermission extends BasicPermission {
     @java.io.Serial
     private static final long serialVersionUID = -8343910153355041693L;
diff --git a/src/java.base/share/classes/java/net/URLConnection.java b/src/java.base/share/classes/java/net/URLConnection.java
index 585ab4fa15aca..9bb9dec045887 100644
--- a/src/java.base/share/classes/java/net/URLConnection.java
+++ b/src/java.base/share/classes/java/net/URLConnection.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1995, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1995, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -822,7 +822,12 @@ public Object getContent(Class<?>[] classes) throws IOException {
      * @throws    IOException if the computation of the permission
      * requires network or file I/O and an exception occurs while
      * computing it.
+     *
+     * @deprecated
+     * Permissions can no longer be used for controlling access to resources
+     * as the Security Manager is no longer supported.
      */
+    @Deprecated(since = "25", forRemoval = true)
     public Permission getPermission() throws IOException {
         return SecurityConstants.ALL_PERMISSION;
     }
diff --git a/src/java.base/share/classes/java/net/URLPermission.java b/src/java.base/share/classes/java/net/URLPermission.java
index daf3e99a6a0e0..bf87cad8077d0 100644
--- a/src/java.base/share/classes/java/net/URLPermission.java
+++ b/src/java.base/share/classes/java/net/URLPermission.java
@@ -143,7 +143,7 @@
  * with initial letter of each word capitalized). Either list can contain a wild-card '*'
  * character which signifies all request methods or headers respectively.
  *
- * @apiNote
+ * @deprecated
  * This permission cannot be used for controlling access to resources
  * as the Security Manager is no longer supported.
  *
@@ -154,6 +154,7 @@
  *      RFC 2732: Format for Literal IPv6 Addresses in URL's
  * @since 1.8
  */
+@Deprecated(since = "25", forRemoval = true)
 public final class URLPermission extends Permission {
 
     @java.io.Serial
diff --git a/src/java.base/share/classes/sun/net/www/protocol/file/FileURLConnection.java b/src/java.base/share/classes/sun/net/www/protocol/file/FileURLConnection.java
index 98ff8709aa4e8..fc947f8977fa9 100644
--- a/src/java.base/share/classes/sun/net/www/protocol/file/FileURLConnection.java
+++ b/src/java.base/share/classes/sun/net/www/protocol/file/FileURLConnection.java
@@ -210,6 +210,8 @@ public synchronized InputStream getInputStream()
     /* since getOutputStream isn't supported, only read permission is
      * relevant
      */
+    @Override
+    @Deprecated(since = "25", forRemoval = true)
     @SuppressWarnings("removal")
     public Permission getPermission() throws IOException {
         if (permission == null) {
diff --git a/src/java.base/share/classes/sun/net/www/protocol/ftp/FtpURLConnection.java b/src/java.base/share/classes/sun/net/www/protocol/ftp/FtpURLConnection.java
index 493fda1c1b33f..be24f1133f2fc 100644
--- a/src/java.base/share/classes/sun/net/www/protocol/ftp/FtpURLConnection.java
+++ b/src/java.base/share/classes/sun/net/www/protocol/ftp/FtpURLConnection.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1994, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1994, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -569,6 +569,8 @@ String guessContentTypeFromFilename(String fname) {
      * @return  The {@code Permission} object.
      */
     @Override
+    @Deprecated(since = "25", forRemoval = true)
+    @SuppressWarnings("removal")
     public Permission getPermission() {
         if (permission == null) {
             int urlport = url.getPort();
diff --git a/src/java.base/share/classes/sun/net/www/protocol/https/HttpsURLConnectionImpl.java b/src/java.base/share/classes/sun/net/www/protocol/https/HttpsURLConnectionImpl.java
index 2096957d28971..26c9e0188d1fb 100644
--- a/src/java.base/share/classes/sun/net/www/protocol/https/HttpsURLConnectionImpl.java
+++ b/src/java.base/share/classes/sun/net/www/protocol/https/HttpsURLConnectionImpl.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2001, 2023, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2001, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -355,6 +355,9 @@ public long getHeaderFieldDate(String name, long defaultValue) {
         return delegate.getHeaderFieldDate(name, defaultValue);
     }
 
+    @Override
+    @Deprecated(since = "25", forRemoval = true)
+    @SuppressWarnings("removal")
     public Permission getPermission() throws IOException {
         return delegate.getPermission();
     }
diff --git a/src/java.base/share/classes/sun/net/www/protocol/jar/JarURLConnection.java b/src/java.base/share/classes/sun/net/www/protocol/jar/JarURLConnection.java
index 85d36fe23207e..3a346308f7166 100644
--- a/src/java.base/share/classes/sun/net/www/protocol/jar/JarURLConnection.java
+++ b/src/java.base/share/classes/sun/net/www/protocol/jar/JarURLConnection.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997, 2022, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 1997, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -77,6 +77,9 @@ public JarEntry getJarEntry() throws IOException {
         return jarEntry;
     }
 
+    @Override
+    @Deprecated(since = "25", forRemoval = true)
+    @SuppressWarnings("removal")
     public Permission getPermission() throws IOException {
         return jarFileURLConnection.getPermission();
     }
diff --git a/src/java.base/share/classes/sun/nio/ch/UnixDomainSockets.java b/src/java.base/share/classes/sun/nio/ch/UnixDomainSockets.java
index 128694cb52d55..66c9fa40f2e23 100644
--- a/src/java.base/share/classes/sun/nio/ch/UnixDomainSockets.java
+++ b/src/java.base/share/classes/sun/nio/ch/UnixDomainSockets.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2020, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2020, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -28,7 +28,6 @@
 import java.io.FileDescriptor;
 import java.io.IOException;
 import java.net.BindException;
-import java.net.NetPermission;
 import java.net.SocketAddress;
 import java.net.UnixDomainSocketAddress;
 import java.nio.channels.UnsupportedAddressTypeException;
@@ -52,9 +51,6 @@ private static class UnnamedHolder {
 
     private static final String tempDir = UnixDomainSocketsUtil.getTempDir();
 
-    private static final NetPermission accessUnixDomainSocket =
-            new NetPermission("accessUnixDomainSocket");
-
     static boolean isSupported() {
         return supported;
     }
diff --git a/src/java.base/windows/classes/sun/net/www/protocol/file/UNCFileURLConnection.java b/src/java.base/windows/classes/sun/net/www/protocol/file/UNCFileURLConnection.java
index d5a510d8f317e..0a86d3942f300 100644
--- a/src/java.base/windows/classes/sun/net/www/protocol/file/UNCFileURLConnection.java
+++ b/src/java.base/windows/classes/sun/net/www/protocol/file/UNCFileURLConnection.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2019, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2019, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -42,6 +42,7 @@ final class UNCFileURLConnection extends FileURLConnection {
 
     @Override
     @SuppressWarnings("removal")
+    @Deprecated(since = "25", forRemoval = true)
     public Permission getPermission() {
         Permission perm = permission;
         if (perm == null) {
diff --git a/src/jdk.net/share/classes/jdk/net/NetworkPermission.java b/src/jdk.net/share/classes/jdk/net/NetworkPermission.java
index 7aac1fb112030..c654f821e9dec 100644
--- a/src/jdk.net/share/classes/jdk/net/NetworkPermission.java
+++ b/src/jdk.net/share/classes/jdk/net/NetworkPermission.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2014, 2024, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2014, 2025, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -32,7 +32,7 @@
  * defined in the jdk.net package. These permissions contain a target
  * name, but no actions list. Callers either possess the permission or not.
  *
- * @apiNote
+ * @deprecated
  * This permission cannot be used for controlling access to resources
  * as the Security Manager is no longer supported.
  *
@@ -41,6 +41,7 @@
  * @since 1.8
  */
 
+@Deprecated(since = "25", forRemoval = true)
 public final class NetworkPermission extends BasicPermission {
 
     private static final long serialVersionUID = -2012939586906722291L;